#include <stdio.h>

void write_help_message(char* arg);
unsigned int convert_a_file(FILE* fileptr, unsigned char *conv_table, unsigned char conv_type);

int main(int argc, char* argv[])
{	const unsigned char win_1250_iso_8859_2[] = { 140, 166, 143, 172, 156, 182, 159, 188, 165, 161, 185, 177, 0, 0 };
	unsigned int changed_bytes;
	unsigned char convtype=0;
	
	FILE *plik;
	printf("Konwerter Windows-1250<==>ISO 8859-2. (C) 2005 Dawid P. Pichen\n");
	if (argc==1 || argc>3) 
	{ printf("\aNiepoprawna liczba argumentow!\n");
	write_help_message(argv[0]);
	return 1;
	}
	if (argv[1][0]=='-') 
	switch (argv[1][1])
	{ case '?': printf("Program dokonuje konwersji standardu polskich znakow diakrytycznych\n");
		printf("zapisanych we wskazanym pliku. Standardowa konwersja to zamiana z kodowania\n");
		printf("Windows 1250 na kodowanie ISO 8859-2.\n\n");
		printf("Uzycie:\n");
		printf("%s plikzrodlowy\t - dokonuje konwersji w pliku plikzrodlowy;\n",argv[0]);
		printf("%s -r plikzrodlowy\t - konwersja odwrotna (ISO 8859-2 na Windows 1250);\n",argv[0]);
		printf("%s -v\t - informacja o wersji programu;\n",argv[0]);
		printf("%s -?\t - wyswietla pomoc.\n",argv[0]);
		return 0;
	  case 'v': printf("Wersja: 1.1\nBuild: %s\n",__DATE__);
				return 0;
	  case 'r': if (argc!=3) 
	  		{ printf("\aNie podano nazwy pliku!\n");
			write_help_message(argv[0]);
			return 1;
			}
	  	convtype = 1;
		break;
	  default: printf("\aNiepoprawny przelacznik!\n");
				write_help_message(argv[0]);
				return 1;
	}
	if (convtype) plik = fopen(argv[2],"r+b"); 
		else plik = fopen(argv[1],"r+b"); 
	if (!plik) { printf("\aNie mozna odczytac podanego pliku!\n");
				write_help_message(argv[0]);
				return 1;
				}
	changed_bytes = convert_a_file(plik, win_1250_iso_8859_2, convtype);
	fclose(plik);
	printf("Wynik:\nPlik: %s\nZmienionych bajtow: %u.\n",argv[1],changed_bytes);
	return 0;
	}

void write_help_message(char* arg)
{ printf("Pomoc: %s -?\n",arg); }

unsigned int convert_a_file(FILE* fileptr, unsigned char *conv_table, unsigned char conv_type)
{ unsigned char read_byte;
unsigned int bytes_changed=0;
unsigned short int index;
while (1)
	{ if (!fread(&read_byte, sizeof(char), 1, fileptr)) break;
	  if (read_byte < 0x80) continue;
	  index = (conv_type?1:0);
	  while (conv_table[index])
	  	{ if (read_byte == conv_table[index])
			{ bytes_changed++;
			fseek(fileptr, -1, 1);
			read_byte = (conv_type?conv_table[index-1]:conv_table[index+1]);
			fwrite(&read_byte, sizeof(char), 1, fileptr);
			fseek(fileptr, 0, SEEK_CUR);
			break;
			}
		index = index+2;
		}
	}
return bytes_changed; 
}